/* WebWindow.c generated by valac 0.38.4, the Vala compiler
 * generated from WebWindow.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <webkit2/webkit2.h>
#include <gdk/gdk.h>
#include <cairo.h>


#define NUVOLA_TYPE_WEB_WINDOW (nuvola_web_window_get_type ())
#define NUVOLA_WEB_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_WINDOW, NuvolaWebWindow))
#define NUVOLA_WEB_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_WINDOW, NuvolaWebWindowClass))
#define NUVOLA_IS_WEB_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_WINDOW))
#define NUVOLA_IS_WEB_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_WINDOW))
#define NUVOLA_WEB_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_WINDOW, NuvolaWebWindowClass))

typedef struct _NuvolaWebWindow NuvolaWebWindow;
typedef struct _NuvolaWebWindowClass NuvolaWebWindowClass;
typedef struct _NuvolaWebWindowPrivate NuvolaWebWindowPrivate;
enum  {
	NUVOLA_WEB_WINDOW_0_PROPERTY,
	NUVOLA_WEB_WINDOW_NUM_PROPERTIES
};
static GParamSpec* nuvola_web_window_properties[NUVOLA_WEB_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NuvolaWebWindow {
	GtkWindow parent_instance;
	NuvolaWebWindowPrivate * priv;
};

struct _NuvolaWebWindowClass {
	GtkWindowClass parent_class;
};

struct _NuvolaWebWindowPrivate {
	WebKitWebView* web_view;
};


static gpointer nuvola_web_window_parent_class = NULL;

GType nuvola_web_window_get_type (void) G_GNUC_CONST;
#define NUVOLA_WEB_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_WEB_WINDOW, NuvolaWebWindowPrivate))
#define NUVOLA_WEB_WINDOW_MINIMAL_WIDTH 100
#define NUVOLA_WEB_WINDOW_MINIMAL_HEIGHT 100
#define NUVOLA_WEB_WINDOW_INITIAL_WIDTH 800
#define NUVOLA_WEB_WINDOW_INITIAL_HEIGHT 600
NuvolaWebWindow* nuvola_web_window_new (WebKitWebView* web_view);
NuvolaWebWindow* nuvola_web_window_construct (GType object_type, WebKitWebView* web_view);
static void nuvola_web_window_on_ready_to_show (NuvolaWebWindow* self);
static void _nuvola_web_window_on_ready_to_show_webkit_web_view_ready_to_show (WebKitWebView* _sender, gpointer self);
static void nuvola_web_window_on_close (NuvolaWebWindow* self);
static void _nuvola_web_window_on_close_webkit_web_view_close (WebKitWebView* _sender, gpointer self);
static void nuvola_web_window_on_title_changed (NuvolaWebWindow* self, GObject* o, GParamSpec* p);
static void _nuvola_web_window_on_title_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void nuvola_web_window_finalize (GObject * obj);


static void _nuvola_web_window_on_ready_to_show_webkit_web_view_ready_to_show (WebKitWebView* _sender, gpointer self) {
	nuvola_web_window_on_ready_to_show ((NuvolaWebWindow*) self);
}


static void _nuvola_web_window_on_close_webkit_web_view_close (WebKitWebView* _sender, gpointer self) {
	nuvola_web_window_on_close ((NuvolaWebWindow*) self);
}


static void _nuvola_web_window_on_title_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	nuvola_web_window_on_title_changed ((NuvolaWebWindow*) self, _sender, pspec);
}


NuvolaWebWindow* nuvola_web_window_construct (GType object_type, WebKitWebView* web_view) {
	NuvolaWebWindow * self = NULL;
	WebKitWebView* _tmp0_;
	WebKitWebView* _tmp1_;
	WebKitWebView* _tmp2_;
	WebKitWebView* _tmp3_;
	WebKitWebView* _tmp4_;
	g_return_val_if_fail (web_view != NULL, NULL);
	self = (NuvolaWebWindow*) g_object_new (object_type, NULL);
	_tmp0_ = web_view;
	self->priv->web_view = _tmp0_;
	_tmp1_ = web_view;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
	_tmp2_ = web_view;
	g_signal_connect_object (_tmp2_, "ready-to-show", (GCallback) _nuvola_web_window_on_ready_to_show_webkit_web_view_ready_to_show, self, 0);
	_tmp3_ = web_view;
	g_signal_connect_object (_tmp3_, "close", (GCallback) _nuvola_web_window_on_close_webkit_web_view_close, self, 0);
	_tmp4_ = web_view;
	g_signal_connect_object ((GObject*) _tmp4_, "notify::title", (GCallback) _nuvola_web_window_on_title_changed_g_object_notify, self, G_CONNECT_AFTER);
	return self;
}


NuvolaWebWindow* nuvola_web_window_new (WebKitWebView* web_view) {
	return nuvola_web_window_construct (NUVOLA_TYPE_WEB_WINDOW, web_view);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void nuvola_web_window_on_ready_to_show (NuvolaWebWindow* self) {
	WebKitWindowProperties* properties = NULL;
	WebKitWebView* _tmp0_;
	WebKitWindowProperties* _tmp1_;
	WebKitWindowProperties* _tmp2_;
	GdkRectangle geom = {0};
	WebKitWindowProperties* _tmp3_;
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _tmp5_;
	gboolean _tmp6_ = FALSE;
	GdkRectangle _tmp7_;
	gint _tmp8_;
	WebKitWebView* _tmp28_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->web_view;
	_tmp1_ = webkit_web_view_get_window_properties (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	properties = _tmp2_;
	_tmp3_ = properties;
	webkit_window_properties_get_geometry (_tmp3_, &_tmp4_);
	_tmp5_ = _tmp4_;
	geom = _tmp5_;
	_tmp7_ = geom;
	_tmp8_ = _tmp7_.width;
	if (_tmp8_ < NUVOLA_WEB_WINDOW_MINIMAL_WIDTH) {
		_tmp6_ = TRUE;
	} else {
		GdkRectangle _tmp9_;
		gint _tmp10_;
		_tmp9_ = geom;
		_tmp10_ = _tmp9_.height;
		_tmp6_ = _tmp10_ < NUVOLA_WEB_WINDOW_MINIMAL_HEIGHT;
	}
	if (_tmp6_) {
		GdkRectangle _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		GdkRectangle _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		_tmp11_ = geom;
		_tmp12_ = _tmp11_.width;
		_tmp13_ = MAX (NUVOLA_WEB_WINDOW_INITIAL_WIDTH, _tmp12_);
		_tmp14_ = geom;
		_tmp15_ = _tmp14_.height;
		_tmp16_ = MAX (NUVOLA_WEB_WINDOW_INITIAL_HEIGHT, _tmp15_);
		gtk_window_set_default_size ((GtkWindow*) self, _tmp13_, _tmp16_);
		gtk_window_maximize ((GtkWindow*) self);
	} else {
		GdkRectangle _tmp17_;
		gint _tmp18_;
		GdkRectangle _tmp19_;
		gint _tmp20_;
		GdkRectangle _tmp21_;
		gint _tmp22_;
		GdkRectangle _tmp23_;
		gint _tmp24_;
		WebKitWindowProperties* _tmp25_;
		gboolean _tmp26_;
		gboolean _tmp27_;
		_tmp17_ = geom;
		_tmp18_ = _tmp17_.x;
		_tmp19_ = geom;
		_tmp20_ = _tmp19_.y;
		gtk_window_move ((GtkWindow*) self, _tmp18_, _tmp20_);
		_tmp21_ = geom;
		_tmp22_ = _tmp21_.width;
		_tmp23_ = geom;
		_tmp24_ = _tmp23_.height;
		gtk_window_set_default_size ((GtkWindow*) self, _tmp22_, _tmp24_);
		_tmp25_ = properties;
		_tmp26_ = webkit_window_properties_get_fullscreen (_tmp25_);
		_tmp27_ = _tmp26_;
		if (_tmp27_) {
			gtk_window_maximize ((GtkWindow*) self);
		}
	}
	_tmp28_ = self->priv->web_view;
	gtk_widget_show ((GtkWidget*) _tmp28_);
	gtk_window_present ((GtkWindow*) self);
	_g_object_unref0 (properties);
}


static void nuvola_web_window_on_close (NuvolaWebWindow* self) {
	g_return_if_fail (self != NULL);
	gtk_widget_hide ((GtkWidget*) self);
	gtk_widget_destroy ((GtkWidget*) self);
}


static void nuvola_web_window_on_title_changed (NuvolaWebWindow* self, GObject* o, GParamSpec* p) {
	WebKitWebView* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (o != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->web_view;
	_tmp1_ = webkit_web_view_get_title (_tmp0_);
	_tmp2_ = _tmp1_;
	gtk_window_set_title ((GtkWindow*) self, _tmp2_);
}


static void nuvola_web_window_class_init (NuvolaWebWindowClass * klass) {
	nuvola_web_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaWebWindowPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_web_window_finalize;
}


static void nuvola_web_window_instance_init (NuvolaWebWindow * self) {
	self->priv = NUVOLA_WEB_WINDOW_GET_PRIVATE (self);
}


static void nuvola_web_window_finalize (GObject * obj) {
	NuvolaWebWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_WEB_WINDOW, NuvolaWebWindow);
	G_OBJECT_CLASS (nuvola_web_window_parent_class)->finalize (obj);
}


GType nuvola_web_window_get_type (void) {
	static volatile gsize nuvola_web_window_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_web_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaWebWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_web_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaWebWindow), 0, (GInstanceInitFunc) nuvola_web_window_instance_init, NULL };
		GType nuvola_web_window_type_id;
		nuvola_web_window_type_id = g_type_register_static (gtk_window_get_type (), "NuvolaWebWindow", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_web_window_type_id__volatile, nuvola_web_window_type_id);
	}
	return nuvola_web_window_type_id__volatile;
}



